#include "memory.h"


FILE *_memoryLog = NULL;


#ifdef MEMORY_CHECK_ENABLED
void mwLogW(FILE *p);
#endif


FILE *memoryLogHandleGet(void) {
	return _memoryLog;
}


#ifdef MEMORY_CHECK_ENABLED
void memoryOutput(int c) {
	fputc(c, _memoryLog);
	fflush(_memoryLog);

#ifdef __linux__
	// Also output to stdout on Linux.
	fputc(c, stdout);
	fflush(stdout);
#endif
}
#endif


void memoryShutdown(void) {
#ifdef MEMORY_CHECK_ENABLED
	unlink("memwatch.log");  // It just insists on creating this!
	mwTerm();
#endif
}


void memoryStartup(char *appName) {
	char *logName = utilAppNameWithNewExtensionGet(appName, "log");

	_memoryLog = fopen(logName, "w");

#ifdef MEMORY_CHECK_ENABLED
	mwLogW(_memoryLog);
	mwSetOutFunc(memoryOutput);
	mwInit();
#endif

	free(logName);
}
